#include <avr/io.h>
#include <util/delay.h>

#include "buzzer.h"


#define BUZZER_OUT	PORTB
#define BUZZER_DDR	DDRB
#define BUZZER		PB7


void timer1_init(void)
{
	TCCR1A = 0x0A;
	TCCR1B = 0x1B;
	TCCR1C = 0x00;
	TCNT1 = 0;
	ICR1 = 0;
	OCR1C = 0;
}

void buzzer_out(unsigned char buz)
{
	unsigned int frequency_table[4] = { 0, 506, 568, 716 };

	if( buz == NONE )	{
		ICR1 = 100;
		OCR1C = 100;
	}
	else {
		ICR1 = frequency_table[buz];
		OCR1C = ICR1 / 2;
	}
}

void buzzer_init(void)
{
	BUZZER_DDR |= 1 << BUZZER;
	BUZZER_OUT |= 1 << BUZZER;

	timer1_init();
}
